Main Page | Namespace List | Class Hierarchy | Alphabetical List | Class List | File List | Namespace Members | Class Members | File Members

# InvertibleRSAFunction Class Reference

`#include <rsa.h>`

Inheritance diagram for InvertibleRSAFunction:

List of all members.

## Detailed Description

_

Definition at line 53 of file rsa.h.

## Public Member Functions
void | Initialize (RandomNumberGenerator &rng, unsigned int modulusBits, const Integer &e=17)
void | Initialize (const Integer &n, const Integer &e, const Integer &d, const Integer &p, const Integer &q, const Integer &dp, const Integer &dq, const Integer &u)
void | Initialize (const Integer &n, const Integer &e, const Integer &d)
| factor n given private exponent
void | BERDecode (BufferedTransformation &bt)
| decode this object from a BufferedTransformation, using BER (Basic Encoding Rules)
void | DEREncode (BufferedTransformation &bt) const
| encode this object into a BufferedTransformation, using DER (Distinguished Encoding Rules)
void | BERDecodeKey (BufferedTransformation &bt)
| decode subjectPublicKey part of subjectPublicKeyInfo, or privateKey part of privateKeyInfo, without the BIT STRING or OCTET STRING header
void | DEREncodeKey (BufferedTransformation &bt) const
| encode subjectPublicKey part of subjectPublicKeyInfo, or privateKey part of privateKeyInfo, without the BIT STRING or OCTET STRING header
Integer | CalculateInverse (RandomNumberGenerator &rng, const Integer &x) const
bool | Validate (RandomNumberGenerator &rng, unsigned int level) const
| check this object for errors
void | GenerateRandom (RandomNumberGenerator &rng, const NameValuePairs &alg)
bool | GetVoidValue (const char *name, const std::type_info &valueType, void *pValue) const
| to be implemented by derived classes, users should use one of the above functions instead
void | AssignFrom (const NameValuePairs &source)
| assign values from source to this object
const Integer & | GetPrime1 () const
const Integer & | GetPrime2 () const
const Integer & | GetPrivateExponent () const
const Integer & | GetModPrime1PrivateExponent () const
const Integer & | GetModPrime2PrivateExponent () const
const Integer & | GetMultiplicativeInverseOfPrime2ModPrime1 () const
void | SetPrime1 (const Integer &p)
void | SetPrime2 (const Integer &q)
void | SetPrivateExponent (const Integer &d)
void | SetModPrime1PrivateExponent (const Integer &dp)
void | SetModPrime2PrivateExponent (const Integer &dq)
void | SetMultiplicativeInverseOfPrime2ModPrime1 (const Integer &u)
void | Initialize (const Integer &n, const Integer &e)
OID | GetAlgorithmID () const
Integer | ApplyFunction (const Integer &x) const
Integer | PreimageBound () const
Integer | ImageBound () const
const Integer & | GetModulus () const
const Integer & | GetPublicExponent () const
void | SetModulus (const Integer &n)
void | SetPublicExponent (const Integer &e)
Integer | ApplyRandomizedFunction (RandomNumberGenerator &rng, const Integer &x) const
bool | IsRandomized () const
virtual Integer | MaxPreimage () const
virtual Integer | MaxImage () const
virtual bool | BERDecodeAlgorithmParameters (BufferedTransformation &bt)
virtual bool | DEREncodeAlgorithmParameters (BufferedTransformation &bt) const
virtual void | BERDecodeKey2 (BufferedTransformation &bt, bool parametersPresent, unsigned int size)
void | Save (BufferedTransformation &bt) const
| save key into a BufferedTransformation
void | Load (BufferedTransformation &bt)
| load key from a BufferedTransformation
virtual void | BEREncode (BufferedTransformation &bt) const
| encode this object into a BufferedTransformation, using BER
virtual void | ThrowIfInvalid (RandomNumberGenerator &rng, unsigned int level) const
| throws InvalidMaterial if this object fails Validate() test
virtual bool | SupportsPrecomputation () const
virtual void | Precompute (unsigned int n)
| do precomputation
virtual void | LoadPrecomputation (BufferedTransformation &storedPrecomputation)
| retrieve previously saved precomputation
virtual void | SavePrecomputation (BufferedTransformation &storedPrecomputation) const
| save precomputation for later use
void | DoQuickSanityCheck () const
template<class T>
bool | GetThisObject (T &object) const
| get a copy of this object or a subobject of it
template<class T>
bool | GetThisPointer (T *&p) const
| get a pointer to this object, as a pointer to T
template<class T>
bool | GetValue (const char *name, T &value) const
| get a named value, returns true if the name exists
template<class T>
T | GetValueWithDefault (const char *name, T defaultValue) const
| get a named value, returns the default if the name doesn't exist
std::string | GetValueNames () const
| get a list of value names that can be retrieved
bool | GetIntValue (const char *name, int &value) const
| get a named value with type int
int | GetIntValueWithDefault (const char *name, int defaultValue) const
| get a named value with type int, with default
template<class T>
void | GetRequiredParameter (const char *className, const char *name, T &value) const
void | GetRequiredIntParameter (const char *className, const char *name, int &value) const
Integer | CalculateRandomizedInverse (RandomNumberGenerator &rng, const Integer &x) const
bool | IsRandomized () const
virtual void | BERDecodeOptionalAttributes (BufferedTransformation &bt)
| decode optional attributes including context-specific tag
virtual void | DEREncodeOptionalAttributes (BufferedTransformation &bt) const
| encode optional attributes including context-specific tag
void | GenerateRandomWithKeySize (RandomNumberGenerator &rng, unsigned int keySize)
| calls the above function with a NameValuePairs object that just specifies "KeySize"
## Static Public Member Functions
static void __cdecl | ThrowIfTypeMismatch (const char *name, const std::type_info &stored, const std::type_info &retrieving)
| used by derived classes to check for type mismatch
## Protected Attributes
Integer | m_d
Integer | m_p
Integer | m_q
Integer | m_dp
Integer | m_dq
Integer | m_u
Integer | m_n
Integer | m_e

## Member Function Documentation

bool InvertibleRSAFunction::Validate | ( | RandomNumberGenerator & | rng,
|  | unsigned int | level
| ) | const`[virtual]`

  | check this object for errors Parameters:
  | level | denotes the level of thoroughness: 0 - using this object won't cause a crash or exception (rng is ignored) 1 - this object will probably function (encrypt, sign, etc.) correctly (but may not check for weak keys and such) 2 - make sure this object will function correctly, and do reasonable security checks 3 - do checks that may take a long time
Returns: true if the tests pass Reimplemented from RSAFunction. Definition at line 243 of file rsa.cpp. References Integer::IsOdd(), Integer::IsPositive(), m_d, m_dp, m_dq, RSAFunction::m_e, RSAFunction::m_n, m_p, m_q, m_u, Integer::One(), and RSAFunction::Validate().

void InvertibleRSAFunction::GenerateRandom | ( | RandomNumberGenerator & | rng,
|  | const NameValuePairs & | alg
| ) | `[virtual]`

| parameters: (ModulusSize, PublicExponent (default 17)) Reimplemented from GeneratableCryptoMaterial. Definition at line 104 of file rsa.cpp. References Integer::GenerateRandom(), NameValuePairs::GetIntValue(), PrimeSelector::GetSelectorPointer(), NameValuePairs::GetValueWithDefault(), Integer::InverseMod(), Integer::IsEven(), Integer::IsPositive(), Name::KeySize(), m_d, m_dp, m_dq, RSAFunction::m_e, RSAFunction::m_n, m_p, m_q, m_u, Name::ModulusSize(), Name::PointerToPrimeSelector(), and Name::PublicExponent(). Referenced by Initialize().

void InvertibleRSAFunction::AssignFrom | ( | const NameValuePairs & | source | ) | `[virtual]`

| assign values from source to this object Note: This function can be used to create a public key from a private key. Reimplemented from RSAFunction. Definition at line 276 of file rsa.cpp.

void ASN1CryptoMaterial::Load | ( | BufferedTransformation & | bt | ) | `[inline, virtual, inherited]`

  | load key from a BufferedTransformation Exceptions:
  | KeyingErr | if decode fails
Note: Generally does not check that the key is valid. Call ValidateKey() or ThrowIfInvalidKey() to check that. Reimplemented from CryptoMaterial. Definition at line 52 of file simple.h. References ASN1Object::BERDecode().

virtual void ASN1Object::BEREncode | ( | BufferedTransformation & | bt | ) | const`[inline, virtual, inherited]`

| encode this object into a BufferedTransformation, using BER this may be useful if DEREncode() would be too inefficient Definition at line 1561 of file cryptlib.h. Referenced by ASN1CryptoMaterial::Save().

virtual bool CryptoMaterial::SupportsPrecomputation | ( |  | ) | const`[inline, virtual, inherited]`

| Returns: whether this object supports precomputation Reimplemented in DL_GroupParameters< T >, DL_PrivateKeyImpl< GP >, DL_PublicKeyImpl< GP >, DL_GroupParameters< Integer >, DL_GroupParameters< typenameEcPrecomputation< EC >::Element >, DL_PrivateKeyImpl< DL_GroupParameters_EC< EC > >, and DL_PublicKeyImpl< DL_GroupParameters_EC< EC > >. Definition at line 998 of file cryptlib.h.

virtual void CryptoMaterial::Precompute | ( | unsigned int | n | ) | `[inline, virtual, inherited]`

| do precomputation The exact semantics of Precompute() is varies, but typically it means calculate a table of n objects that can be used later to speed up computation. Reimplemented in DL_GroupParameters< T >, DL_PrivateKeyImpl< GP >, DL_PublicKeyImpl< GP >, DL_GroupParameters< Integer >, DL_GroupParameters< typenameEcPrecomputation< EC >::Element >, DL_PrivateKeyImpl< DL_GroupParameters_EC< EC > >, and DL_PublicKeyImpl< DL_GroupParameters_EC< EC > >. Definition at line 1003 of file cryptlib.h.

bool NameValuePairs::GetIntValue | ( | const char * | name,
|  | int & | value
| ) | const`[inline, inherited]`

| get a named value with type int used to ensure we don't accidentally try to get an unsigned int or some other type when we mean int (which is the most common case) Definition at line 278 of file cryptlib.h. Referenced by InvertibleRWFunction::GenerateRandom(), GenerateRandom(), InvertibleRabinFunction::GenerateRandom(), InvertibleLUCFunction::GenerateRandom(), DL_GroupParameters_IntegerBased::GenerateRandom(), DL_GroupParameters_DSA::GenerateRandom(), InvertibleESIGNFunction::GenerateRandom(), and Integer::GenerateRandomNoThrow().

void PKCS8PrivateKey::BERDecodeOptionalAttributes | ( | BufferedTransformation & | bt | ) | `[virtual, inherited]`

| decode optional attributes including context-specific tag /note default implementation stores attributes to be output in DEREncodeOptionalAttributes Definition at line 578 of file asn.cpp. Referenced by PKCS8PrivateKey::BERDecode().

The documentation for this class was generated from the following files:

- rsa.h
- rsa.cpp